"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    isMatch: function() {
        return isMatch;
    },
    firstMatch: function() {
        return firstMatch;
    },
    matches: function() {
        return matches;
    }
});
var _functionTimeout = /*#__PURE__*/ _interopRequireWildcard(require("function-timeout"));
var _timeSpan = /*#__PURE__*/ _interopRequireDefault(require("time-span"));
var _cloneRegexp = /*#__PURE__*/ _interopRequireDefault(require("clone-regexp"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _getRequireWildcardCache(nodeInterop) {
    if (typeof WeakMap !== "function") return null;
    var cacheBabelInterop = new WeakMap();
    var cacheNodeInterop = new WeakMap();
    return (_getRequireWildcardCache = function(nodeInterop) {
        return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
    })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
    if (!nodeInterop && obj && obj.__esModule) {
        return obj;
    }
    if (obj === null || typeof obj !== "object" && typeof obj !== "function") {
        return {
            default: obj
        };
    }
    var cache = _getRequireWildcardCache(nodeInterop);
    if (cache && cache.has(obj)) {
        return cache.get(obj);
    }
    var newObj = {};
    var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
    for(var key in obj){
        if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) {
            var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
            if (desc && (desc.get || desc.set)) {
                Object.defineProperty(newObj, key, desc);
            } else {
                newObj[key] = obj[key];
            }
        }
    }
    newObj.default = obj;
    if (cache) {
        cache.set(obj, newObj);
    }
    return newObj;
}
var __generator = (void 0) && (void 0).__generator || function(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
};
var _groups;
var resultToMatch = function(result) {
    return {
        match: result[0],
        index: result.index,
        groups: result.slice(1),
        namedGroups: (_groups = result.groups) !== null && _groups !== void 0 ? _groups : {},
        input: result.input
    };
};
function isMatch(regex, string) {
    var timeout = (arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}).timeout;
    try {
        return (0, _functionTimeout.default)(function() {
            return (0, _cloneRegexp.default)(regex).test(string);
        }, {
            timeout: timeout
        })();
    } catch (error) {
        if ((0, _functionTimeout.isTimeoutError)(error)) {
            return false;
        }
        throw error;
    }
}
function firstMatch(regex, string) {
    var timeout = (arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}).timeout;
    try {
        var result = (0, _functionTimeout.default)(function() {
            return (0, _cloneRegexp.default)(regex).exec(string);
        }, {
            timeout: timeout
        })();
        if (result === null) {
            return;
        }
        return resultToMatch(result);
    } catch (error) {
        if ((0, _functionTimeout.isTimeoutError)(error)) {
            return;
        }
        throw error;
    }
}
function matches(regex, string) {
    var ref = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, _timeout = ref.timeout, timeout = _timeout === void 0 ? Number.POSITIVE_INFINITY : _timeout, _matchTimeout = ref.matchTimeout, matchTimeout = _matchTimeout === void 0 ? Number.POSITIVE_INFINITY : _matchTimeout;
    if (!regex.global) {
        throw new Error("The regex must have the global flag, otherwise, use `firstMatch()` instead");
    }
    return _defineProperty({}, Symbol.iterator, function() {
        var matches, nextMatch, end, ref, value, done, error;
        return __generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    _state.trys.push([
                        0,
                        4,
                        ,
                        5
                    ]);
                    matches = string.matchAll(regex); // The regex is only executed when iterated over.
                    _state.label = 1;
                case 1:
                    if (!true) return [
                        3,
                        3
                    ];
                    nextMatch = (0, _functionTimeout.default)(function() {
                        return matches.next();
                    }, {
                        timeout: timeout !== Number.POSITIVE_INFINITY || matchTimeout !== Number.POSITIVE_INFINITY ? Math.min(timeout, matchTimeout) : undefined
                    }); // `matches.next` must be called within an arrow function so that it doesn't loose its context.
                    end = (0, _timeSpan.default)();
                    ref = nextMatch(), value = ref.value, done = ref.done;
                    timeout -= Math.ceil(end());
                    if (done) {
                        return [
                            3,
                            3
                        ];
                    }
                    return [
                        4,
                        resultToMatch(value)
                    ];
                case 2:
                    _state.sent();
                    return [
                        3,
                        1
                    ];
                case 3:
                    return [
                        3,
                        5
                    ];
                case 4:
                    error = _state.sent();
                    if (!(0, _functionTimeout.isTimeoutError)(error)) {
                        throw error;
                    }
                    return [
                        3,
                        5
                    ];
                case 5:
                    return [
                        2
                    ];
            }
        });
    });
}
